//
// © 2014 David Vines
//
// Creative Commons License
//
// This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
//

/* globals Game: true */

Game.Map.Cave = function(tiles,player) {
    Game.Map.call(this,tiles);
    this._temple = this.getRandomFloorPosition(this.getDepth()-1);
    this._tiles[this.getDepth()-1][this._temple.x][this._temple.y] = Game.Tile.templeEntranceTile;

    this._entrance = this.getRandomFloorPosition(0);
    this._tiles[0][this._entrance.x][this._entrance.y] = Game.Tile.caveExitTile;
    
    var easy = Math.floor(this._depth/4);
    var med  = Math.floor(2*this._depth/4);
    var hard  = Math.floor(3*this._depth/4);
    
    var diff = function(depth) { 
        if (depth < easy) {
            return 0;
        } 
        else if (depth < med) { 
            return 1;
        } 
        else if (depth < hard) {
            return 2;
        } else  { 
            return 3;
        }
    };
    
    var entityTemplates = [ [Game.FungusTemplate, Game.BatTemplate],
                            [Game.FungusTemplate, Game.BatTemplate, Game.SpiderTemplate],
                            [Game.FungusTemplate, Game.BatTemplate, Game.SpiderTemplate, Game.ScorpionTemplate],
                            [Game.FungusTemplate, Game.BatTemplate, Game.SpiderTemplate, Game.ScorpionTemplate, Game.PossessedHumanTemplate],
                          ];
    var itemTemplates = [ [ Game.SwordTemplate, Game.ShieldTemplate, Game.TorchTemplate,
                            Game.TorianMuseliTemplate
                          ],
                          [ Game.SwordTemplate, Game.LeatherArmourTemplate, Game.ChainArmourTemplate,
                            Game.ShieldTemplate, Game.TorchTemplate,
                            Game.MaceTemplate, Game.TorianMuseliTemplate, Game.TorianHoneyTemplate
                          ],
                          [ Game.SwordTemplate, Game.LeatherArmourTemplate, Game.ChainArmourTemplate,
                            Game.SuperiorChainArmourTemplate, Game.ShieldTemplate, Game.TorchTemplate,
                            Game.MaceTemplate, Game.TorianMuseliTemplate, Game.TorianHoneyTemplate,
                            Game.TorianMeadTemplate
                          ],
                          [ Game.SwordTemplate, Game.LeatherArmourTemplate, Game.ChainArmourTemplate,
                            Game.SuperiorChainArmourTemplate, Game.ShieldTemplate, Game.TorchTemplate,
                            Game.MaceTemplate, Game.TorianMuseliTemplate, Game.TorianHoneyTemplate,
                            Game.TorianMeadTemplate
                          ]
                        ];
    for(var z=0; z<this._depth; z++) {
        for(var i=0; i<25; i++) {
            this.addEntityAtRandomFloorPosition(new Game.Entity(entityTemplates[diff(z)].random()),z);
        }
        for(i=0; i<15; i++) {
            this.addItemAtRandomFloorPosition(new Game.Item(itemTemplates[diff(z)].random()),z);
        }
    }
};

Game.Map.Cave.extend(Game.Map);

Game.Map.Cave.prototype.putAtEntrance = function(entity) {
    entity.setX(this._entrance.x);
    entity.setY(this._entrance.y);
    entity.setZ(0);
    this.addEntity(entity);
};

Game.Map.Cave.prototype.putAtTemple = function(entity) {
    entity.setX(this._temple.x);
    entity.setY(this._temple.y);
    entity.setZ(this.getDepth()-1);
    this.addEntity(entity);
};