//
// © 2014 David Vines
//
// Creative Commons License
//
// This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
//

/* globals Game: true */

Game.PlayerTemplate = {
    name: 'the player',
    character: '@',
    foreground: 'white',
    sightRadius: 3,
    inventorySlots: Game._screenHeight-3,
    mixins: [Game.EntityMixins.Moveable, Game.EntityMixins.PlayerActor,  Game.EntityMixins.HumanFighter,    Game.EntityMixins.MessageReader, 
             Game.EntityMixins.Sight,    Game.EntityMixins.FightHandler, Game.EntityMixins.InventoryHolder, Game.EntityMixins.Equipper,
             Game.EntityMixins.Learner,  Game.EntityMixins.User
            ]
};

Game.FungusTemplate = {
    name: 'fungus',
    character: 'Ω',
    foreground: 'green',
    speed: 250,
    xp: 7,
    mixins: [Game.EntityMixins.FungusActor, Game.EntityMixins.PassiveFighter]
};

Game.BatTemplate = {
    name: 'bat',
    character: 'ω',
    foreground: 'chocolate',
    speed: 2000,
    damage: function() {
        if (Game.Rules.formUnderlyingSelected() === "2014a") {
            return 1;
        } else {
            return 1;
        }
    },
    xp: 20,
    mixins: [Game.EntityMixins.Moveable, Game.EntityMixins.TaskActor, Game.EntityMixins.SimpleFighter, Game.EntityMixins.Moody, Game.EntityMixins.Sight]
};

Game.SpiderTemplate = {
    name: 'giant spider',
    character: '☼',
    foreground: 'red',
    woundPoints: 15,
    morale: 175,
    skill: 15,
    damage: function() {
        if (Game.Rules.formUnderlyingSelected() === "2014a") {
            return 2;
        } else {
            return 2;
        }
    },
    xp: 50,
    tasks: ['hunt','wander'],
    mixins: [Game.EntityMixins.Moveable, Game.EntityMixins.TaskActor, Game.EntityMixins.SimpleFighter, Game.EntityMixins.Sight]
};

Game.ScorpionTemplate = {
    name: 'giant scorpion',
    character: 'ʡ',
    foreground: 'red',
    woundPoints: 15,
    morale: 175,
    skill: 25,
    damage: function() {
        if (Game.Rules.formUnderlyingSelected() === "2014a") {
            return 3;
        } else {
            return 5;
        }
    },
    xp:100,
    tasks: ['hunt','wander'],
    mixins: [Game.EntityMixins.Moveable, Game.EntityMixins.TaskActor, Game.EntityMixins.SimpleFighter, Game.EntityMixins.Sight]
};

Game.PossessedHumanTemplate = {
    name: 'possessed human',
    character: 'ῼ',
    foreground: 'red',
    woundPoints: 15,
    morale: 175,
    skill: 25,
    damage: function() {
        if (Game.Rules.formUnderlyingSelected() === "2014a") {
            return 4;
        } else {
            return 6;
        }
    },
    xp:100,
    tasks: ['hunt','wander'],
    mixins: [Game.EntityMixins.Moveable,        Game.EntityMixins.InventoryHolder, Game.EntityMixins.Equipper,
             Game.EntityMixins.PossessedHuman,  Game.EntityMixins.MessageReader,   Game.EntityMixins.Sight,
             Game.EntityMixins.HumanFighter,    Game.EntityMixins.TaskActor
            ]
};


Game.DemonTemplate = {
    name: 'demon',
    character: 'Ð',
    foreground: 'red',
    woundPoints: 45,
    morale: 250,
    skill: 75,
    damage: function() {
        if (Game.Rules.formUnderlyingSelected() === "2014a") {
            return 6;
        } else {
            return 9;
        }
    },
    xp:250,
    tasks: ['hunt','wander'],
    mixins: [Game.EntityMixins.Moveable,        Game.EntityMixins.InventoryHolder, Game.EntityMixins.Equipper,
             Game.EntityMixins.PossessedHuman,  Game.EntityMixins.MessageReader,   Game.EntityMixins.Sight,
             Game.EntityMixins.HumanFighter,    Game.EntityMixins.TaskActor
            ]
};