//
// © 2014 David Vines
//
// Creative Commons License
//
// This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
//

/* globals Game: true */

Game.ItemMixins = {};

/* jshint sub:true */
Game.ItemMixins.Equippable = {
    name: 'Equippable',
    init: function(template) {
        this._damage = template['damage'] || 0;
        this._skillname = template['skillname'] || null;
        this._armour = template['armour'] || {leftLeg: 0, rightLeg: 0, abdomen:0, chest:0, swordArm:0, shieldArm:0, head:0};
        this._wieldable = template['wieldable'] || false;
        this._shieldable = template['shieldable'] || false;
        this._wearable = template['wearable'] || false;
        this._encumbrance = template['encumbrance'] || 0;
        this._additionalLight = template['additionalLight'] || 0;
    },
    getDamage: function() {
            return this._damage;
    },
    getSkillName: function() {
        return this._skillname;
    },
    getArmour: function() {
        return this._armour;
    },
    isWieldable: function() {
        return this._wieldable;
    },
    isShieldable: function() {
        return this._shieldable;
    },
    isWearable: function() {
        return this._wearable;
    },
    getEncumbrance: function() {
        return this._encumbrance;
    },
    getAdditionalLight: function() {
        return this._additionalLight;
    }
};

Game.ItemMixins.Useable = {
    name: 'Useable',
    init: function(template) {
        this._healsMorale = template['healsMorale'] || false;
        this._heals = template['heals'] || "none";
    },
    isHealingMorale: function() {
        return this._healsMorale;
    },
    getHeals: function() {
        return this._heals;
    }
};